<?php

require_once dirname(__FILE__).'/config.php';

$smarty =& TemplateEngine::getInstance();

function readboosterquarantineFile()
{
	$filename = BOOST_QUARANTINE_FILE;
	$file_contents = '';
	$handle = fopen($filename, "r");
	$size = filesize($filename);
	if($size > 0)
	{
		$file_contents = fread($handle, $size);
	}
	return $file_contents;
}


function checknCreatePhpFile($my_name)
{
	global $lang;
	$filename = BOOST_QUARANTINE_FILE;
	$smarty =& TemplateEngine::getInstance();

	if (!file_exists($filename))
	{
		if (!file_exists(dirname($filename)))
		{
			mkdir(dirname($filename));
		}
		$handle = fopen($filename, 'w');
		$ok = fwrite($handle, ' ');
		fclose($handle);

		#.htaccess
		$htaccess = SHARE_DIR."/".$my_name."/.htaccess";
		$handle = fopen($htaccess, 'w');
		$okh = fwrite($handle, "deny from all");
		fclose($handle);

		if (!$ok)
		{
			$smarty->append('warning',$lang['boostabuse_cannot_create_file']);
		}
	}
}

function defaut($my_name,$my_url)
{
	global $lang, $Boost_php_ok;

	$code_for_booster = "
		//--------------- Start boostabuse -----------------------<br>
		if(file_exists('plugins/boostabuse/msg_booster_abuse.php')) {<br>
			&nbsp;&nbsp;require_once ('plugins/boostabuse/msg_booster_abuse.php');<br>
			&nbsp;&nbsp;if (booster_abuse(\$link_id)) {<br>
			&nbsp;&nbsp;&nbsp;&nbsp;  return;<br>
			&nbsp;&nbsp;}<br>
		}<br>
		//--------------- End boostabuse -------------------------";

	checknCreatePhpFile($my_name);
	$file_contents = readboosterquarantineFile();
	
	$config_manager =& MyConfigManager::getInstance();
	$CONFIG = $config_manager->getConfig();
	
	$filename = SCRIPT_ROOT_PATH.'/include/boost.php';
	$file_contents_test = '';
	$handle = fopen($filename, "r");
	$size = filesize($filename);
	if($size > 0)
	{
		$file_contents_test = fread($handle, $size);
	}
   
	$contenu_array = explode("\n",$file_contents_test);
	
	for($i=0;$i<sizeof($contenu_array);$i++) {
		if (strstr($contenu_array[$i],'booster_abuse')) {
			$booster_abuse_exist = true;
			$Boost_php_ok = true;
			break;
		}
	} 
  
	if ($booster_abuse_exist<>true) {
		rewriteboostphp($contenu_array,$code_for_booster);
	}

	Buffer::str('<form action="'.$my_url.'" method="post">');
	Buffer::str('<table width="100%">');
	
	Buffer::str('<tr>');
	Buffer::str('<td colspan="2">');
	Buffer::str('<h2>'.$lang['boostabuse_label'].'</h2><br />');
	Buffer::str('</td>');
	Buffer::str('</tr>');
	
	Buffer::str('<tr>');
	Buffer::str('<td>');
	Buffer::str($lang['id_booster_quarantine'].' : ');
	Buffer::str('</td>');
	Buffer::str('<td>');
	Buffer::str('<input type="text" name="boost_quarantaine" value="'.$file_contents.'" />');
	Buffer::str('</td>');
	Buffer::str('</tr>');

	Buffer::str('<tr>');
	Buffer::str('<td colspan="2">');
	Buffer::str('<input type="hidden" name="do" value="updateboostquarantaine" />');
	Buffer::str('<br /><center><input type="submit" value="'.$lang['submit'].'" /></center>');
	Buffer::str('</td>');
	Buffer::str('<td>');

	Buffer::str('</table>');
	Buffer::str('</form>');
	
	Buffer::str('<h2>'.' '.'</h2>');

	if ($Boost_php_ok) {
		Buffer::str($lang['boostabuse_php_code_OK'].'<br><br>');
	} else {
		Buffer::str('<strong>'.$lang['boostphp_update_ko'].'</strong><br>');
		Buffer::str($lang['boostabuse_php_code_KO'].'<br><br>');
	}
	
	Buffer::str('<div align=left><tt><big>'.$code_for_booster.'</big></tt></div>');
}

function writeboostquarantaine($my_name, $my_url)
{
	global $lang;

	$smarty =& TemplateEngine::getInstance();
	$myts =& MyTextSanitizer::getInstance();

	$handle = fopen(BOOST_QUARANTINE_FILE, 'w');
	$boost_quarantaine = isset($_POST['boost_quarantaine']) ? $myts->stripSlashesGPC($_POST['boost_quarantaine']) : '';
	$ok = fwrite($handle, $boost_quarantaine);
	fclose($handle);

	#.htaccess
	$htaccess = SHARE_DIR."/".$my_name."/.htaccess";
	$handle = fopen($htaccess, 'w');
	$okh = fwrite($handle, "deny from all");
	fclose($handle);

	if ($ok)
	{
		$smarty->append('warning',$lang['boostabuse_update_ok']);
	}
	else
	{
		$smarty->append('warning',$lang['boostabuse_update_ok']); 
	}
}

function rewriteboostphp($contenu_array,$code_for_booster)
{
		global $lang,$Boost_php_ok;
	
		$code_for_booster_php = preg_replace(array('/<br>/','/&nbsp;/'),'',$code_for_booster);
		$smarty =& TemplateEngine::getInstance();
		$myts =& MyTextSanitizer::getInstance();
	
		$handle = fopen(SCRIPT_ROOT_PATH.'/include/boost.php', 'w');
	
		for($i=0;$i<sizeof($contenu_array);$i++) {
			if (strstr($contenu_array[$i],'if($link_id != 0)')) {
				if (strstr($contenu_array[$i+1],'{')) {
					$contenu_array[$i+1] .= $code_for_booster_php;
					$Boost_php_ok = true;
				} elseif (strstr($contenu_array[$i+2],'{')) {
					$contenu_array[$i+2] .= $code_for_booster_php;
					$Boost_php_ok = true;
				}
			}

			fwrite($handle, $contenu_array[$i]."\n");
		} 

	fclose($handle);

	if ($Boost_php_ok) {
		$smarty->append('warning',$lang['boostphp_update_ok']);
	} else {
		$smarty->append('warning',$lang['boostphp_update_ko']); 
	}
}


$do = isset($_POST['do']) ? $_POST['do'] : '';

switch($do)
{
	case 'updateboostquarantaine':
		writeboostquarantaine($my_name, $my_url);
		break;
}

defaut($my_name,$my_url);
?>